diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/client.h ircd-hybrid-6.0/include/client.h
--- ircd-hybrid-6.0.orig/include/client.h	Tue Jun 19 00:12:03 2001
+++ ircd-hybrid-6.0/include/client.h	Mon Jun 18 23:39:29 2001
@@ -414,6 +414,7 @@
 #define UMODE_GRANT          45
 #define UMODE_SENDOPERWALL   46
 #define UMODE_SEEOPERPRIVS   47
+#define UMODE_SEEROUTING     48
 
 /* *sigh* overflow flags */
 #define FLAGS2_RESTRICTED   0x0001      /* restricted client */
@@ -544,6 +545,7 @@
 /* Changing another user's umode */
 #define CanChangeModes(x)       (TestBit((x)->umodes,UMODE_SETNAME))
 #define CanGrantModes(x)        (TestBit((x)->umodes,UMODE_GRANT))
+#define CanSeeRouting(x)        (TestBit((x)->umodes,UMODE_SEEROUTING))
 
 #define SeesAllConnections(x)	(TestBit((x)->umodes,UMODE_AUSPEX))
 #define IsIdentifiedNick(x)     (TestBit((x)->umodes,UMODE_IDENTIFIED))
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/umodes.h ircd-hybrid-6.0/include/umodes.h
--- ircd-hybrid-6.0.orig/include/umodes.h	Tue Jun 19 00:12:03 2001
+++ ircd-hybrid-6.0/include/umodes.h	Mon Jun 18 23:34:37 2001
@@ -72,6 +72,7 @@
   {UMODE_SERVNOTICE, 's'},
   {UMODE_UNKLINE, 'U'},
   {UMODE_SEEOPERPRIVS, 'v'},
+  {UMODE_SEEROUTING, 'V'},
   {UMODE_WALLOP, 'w'},
   {UMODE_SENDWALLOPS, 'W'},
   {UMODE_EXTERNAL, 'x'},
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_links.c ircd-hybrid-6.0/src/m_links.c
--- ircd-hybrid-6.0.orig/src/m_links.c	Tue Jun 19 00:12:02 2001
+++ ircd-hybrid-6.0/src/m_links.c	Mon Jun 18 23:46:16 2001
@@ -202,9 +202,9 @@
             p = "(Unknown Location)";
 
 #ifdef SERVERHIDE
-          if (strlen(acptr->name) < 6 || strcmp(".quiet", (acptr->name)+(strlen(acptr->name)-6)) || strcmp(".local", (acptr->name)+(strlen(acptr->name)-6)) )
+          if (strlen(acptr->name) < 6 || strcmp(".quiet", (acptr->name)+(strlen(acptr->name)-6)) || strcmp(".local", (acptr->name)+(strlen(acptr->name)-6)) || CanSeeRouting(sptr))
             sendto_one(sptr, form_str(RPL_LINKS),
-                      me.name, parv[0], acptr->name, NETWORK_NAME,
+                      me.name, parv[0], acptr->name, CanSeeRouting(sptr) ? acptr->serv->up : NETWORK_NAME,
                        0, p);
 #else
           sendto_one(sptr, form_str(RPL_LINKS),
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_map.c ircd-hybrid-6.0/src/m_map.c
--- ircd-hybrid-6.0.orig/src/m_map.c	Tue Jun 19 00:12:02 2001
+++ ircd-hybrid-6.0/src/m_map.c	Mon Jun 18 23:57:03 2001
@@ -105,10 +105,20 @@
         }
     }
 
-  header_length = 0;
-  header[0] = '\0';
-  map_send_server(sptr, parv[0], &me);
-  sendto_one(sptr,form_str(RPL_ENDOFMAP),me.name,parv[0]);
+  if (CanSeeRouting(sptr))
+    {
+      header_length = 0;
+      header[0] = '\0';
+      map_send_server(sptr, parv[0], &me);
+      sendto_one(sptr,form_str(RPL_ENDOFMAP),me.name,parv[0]);
+    }
+  else
+    {
+      if (SeesOperMessages(sptr))
+	sendto_one(sptr,":%s NOTICE %s :You have no V umode", me.name, parv[0]);
+      else
+	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+    }
 
   return 0;
 }
